# Ansible role: labocbz.deploy_apacheds

![Licence Status](https://img.shields.io/badge/licence-MIT-brightgreen)
![Testing Method](https://img.shields.io/badge/Testing%20Method-Ansible%20Molecule-blueviolet)
![Testing Driver](https://img.shields.io/badge/Testing%20Driver-docker-blueviolet)
![Language Status](https://img.shields.io/badge/language-Ansible-red)
![Compagny](https://img.shields.io/badge/Compagny-Labo--CBZ-blue)
![Author](https://img.shields.io/badge/Author-Lord%20Robin%20Crombez-blue)

## Description

![Tag: Ansible](https://img.shields.io/badge/Tech-Ansible-orange)
![Tag: Debian](https://img.shields.io/badge/Tech-Debian-orange)
![Tag: Ubuntu](https://img.shields.io/badge/Tech-Ubuntu-orange)
![Tag: SSL/TLS](https://img.shields.io/badge/Tech-SSL/TLS-orange)
![Tag: Java](https://img.shields.io/badge/Tech-Java-orange)
![Tag: ApacheDS](https://img.shields.io/badge/Tech-ApacheDS-orange)
![Tag: LDAP](https://img.shields.io/badge/Tech-LDAP-orange)
![Tag: LDAPS](https://img.shields.io/badge/Tech-LDAPS-orange)

An Ansible playbook to deploy and configure ApacheDS on your host.

This playbook simplifies the installation and deployment of Apache Directory Server instances. The process begins by installing ApacheDS and subsequently copying the default instances to create the requested instances. Passwords and ports are also customized, and the instances are launched as services.

With this playbook, you can easily set up and manage ApacheDS instances, ensuring they meet your specific requirements. It's a powerful tool for streamlining the deployment of directory services and enhancing your directory server environment. Additionally, the role install_apacheds allows you to define a complex LDAP structure using variables from the inventory, enabling detailed customization of users, groups, domains, and organizational units.

## Usage

```SHELL
# Install husky and init
npm i && npx husky init && npm i validate-branch-name && npm cz

# Initialize the local secrets database, if not already present
MSYS_NO_PATHCONV=1 docker run -it --rm -v "$(pwd):/app" -w /app labocbz/devops-linters:latest detect-secrets scan --exclude-files 'node_modules' > .secrets.baseline

# Decrypt the local Ansible Vault
# Get the Ansible Local Vault Key on PassBolt and create the .ansible-vault.key file, after that you can unlock your local vault
MSYS_NO_PATHCONV=1 docker run --rm -it -v "$HOME/.docker:/root/.docker" -v "$(pwd):/root/ansible/${DIR}" -w /root/ansible/${DIR} labocbz/ansible-molecule:latest /bin/sh -c 'cat ./.ansible-vault.key > /tmp/.ansible-vault.key && chmod -x /tmp/.ansible-vault.key && ansible-vault decrypt --vault-password-file /tmp/.ansible-vault.key ./tests/inventory/group_vars/vault.yml'
```

### Linters

```SHELL
# Analyse the project for secrets, and audit
./detect-secrets

# Lint Markdown
MSYS_NO_PATHCONV=1 docker run --rm -v "$(pwd):/app" -w /app labocbz/devops-linters:latest markdownlint './**.md' --disable MD013

# Lint YAML
MSYS_NO_PATHCONV=1 docker run --rm -v "$(pwd):/app" -w /app labocbz/devops-linters:latest yamllint -c ./.yamllint .

# Lint Ansible
MSYS_NO_PATHCONV=1 docker run --rm -v "$(pwd):/app" -w /app labocbz/devops-linters:latest ansible-lint --offline --exclude node_modules -x meta-no-info -p .
```

### Local Tests

This repository contain a unique Molecule controller to start containers and tests your roles and playbook inside them.

```SHELL
# Start the Molecule controller
./molecule-controller

# Inside the controller
molecule create
molecule converge
molecule verify
molecule test
```

In order to use this playbook, you have to know its required roles, their vars and their purppose. Further information [here](./roles/requirements.yml).

### Deployment diagramm

![Deployment-Diagram](./assets/Deployment-Diagram.svg)

## Architectural Decisions Records

Here you can put your change to keep a trace of your work and decisions.

### 2023-10-16: First Init

* First init of this playbook with the bootstrap_playbook playbook by Lord Robin Crombez

### 2023-10-19: Fix and push

* Playbook deploy ApacheDS
* Multiple instance are possible
* TLS available
* Edit of the default password

### 2023-12-16: System users

* Playbook can now use system users and address groups
* Updated with 10 years cert

### 2023-12-18: Fix and tests

* Fix default install
* Fix Java install
* Add tests for Java
* Boolean vars based deployment
* System user fix

### 2024-02-02: Latest

* Use latest version of role

### 2024-03-02: Remastered

* Imported new CICD
* Rework global on readme
* Rename of vars __ and refacto
* Removed free / remote user

### 2024-05-19: New CI

* Added Markdown lint to the CICD
* Rework all Docker images
* Change CICD vars convention
* New workers
* Removed all automation based on branch

### 2024-11-24: Global refactoring

* Use latest version of roles
* Playbook handle users and Java
* You can now install ApacheDS and define the whole strucure of your LDAP (o, ou, account, cn, etc)

### 2024-11-17: Fix inventories

* Moove som vars in other group
* Use the vault for tests secrets

### 2025-01-01: New CICD and images

* Edited all Docker images
* Rework on the CICD
* Enabled SonarQube

### 2025-01-05: Certificates update

* Edit for use the latest version of import_certificates

## Authors

* Lord Robin Crombez

## Sources

* [Ansible role documentation](https://docs.ansible.com/ansible/latest/playbook_guide/playbooks_reuse_roles.html)
* [Ansible Molecule documentation](https://molecule.readthedocs.io/)
